		-----------------------------------
		--  Program to Install Euphoria  --
		--  (see install.doc)            --
		-----------------------------------

constant KEYBOARD = 0, SCREEN = 1
constant SUCCESS = 1, FAILURE = 0, NO_EDIT = 2
constant TRUE = 1, FALSE = 0
constant CLEAR = 0, NO_CLEAR = 2

	-------------------------------------------------
	-- Subdirectory structure for Euphoria files.  --
	-------------------------------------------------

constant file_list = {
  {"REGISTER",
   "REGISTER.DOC", "HOW2REG.EX"},
    
  {"DEMO",
   "DEMO.DOC", "ANIMAL.EX", "ALLSORTS.EX", "EXAMPLE.EX", "SIMPLE.EX", 
   "LEARN.EX", "SANITY.EX", "QUEENS.EX", "BUZZ.EX", "MYDATA.EX", 
   "CSORT.EX", "TREE.EX", "HASH.EX"},
  
  {"DEMO\\DOS32",
   "DOS32.DOC", "BITMAP.EX", "PLOT3D.EX", "SB.EX", "SELECT.E", "TTT.EX", 
   "WIRE.EX", "MOUSE.EX", "MSET.EX", "POLYGON.EX", "CALLMACH.EX", "STEREO.EX", 
   "PICTURE", "DOSINT.EX", "HARDINT.EX"},
  
  {"DEMO\\WIN32",
   "WIN32.DOC" , "EMAIL.EXW", "WINDOW.EXW", "WINWIRE.EXW", "DSEARCH.EXW"},

  {"DEMO\\LANGWAR", 
   "LW.DOC", "LW.SUM", "WEAPONS.E", "SCREEN.E", "COMMANDS.E", "DAMAGE.E",  
   "DISPLAY.E", "EMOVE.E", "ENEMY.E", "SCHED.E", "VARS.E", "SOUNDEFF.E",  
   "LW.EX"},   

  {"DEMO\\BENCH", 
   "BENCH.DOC", "SHELL.EX", "SHELL.BAS", "DATABASE.EX", "DATABASE.BAS", 
   "SIEVE.EX", "SIEVE.BAS", "SEQUENCE.EX", "SEQUENCE.BAS", "FILESORT.EX"},   
  
  {"INCLUDE", 
   "GRAPHICS.E", "SORT.E", "GET.E", "MOUSE.E", "FILE.E", "MACHINE.E",
   "WILDCARD.E", "IMAGE.E", "SAFE.E", "DLL.E", "MISC.E", "MSGBOX.E"},

  {"BIN", 
   "BIN.DOC", "SYNCOLOR.E", "LINES.BAT", "LINES.EX", "EPRINT.EX", "GURU.BAT",
   "GURU.EX", "EPRINT.BAT", "ED.BAT", "ED.EX", "KEYWORDS.E", "CDGURU.BAT", 
   "SEARCH.EX", "SEARCH.BAT", "BIND.BAT", "BINDW.BAT",
   "SHROUD.BAT", "EX.EXE", "EXW.EXE", "ASCII.EX", "ASCII.BAT", "WHERE.EX", 
   "WHERE.BAT", "BIND.EX", "KEY.BAT", "KEY.EX"},
  
  {"DOC", 
   "OVERVIEW.DOC", "WHAT2DO.DOC", "ED.DOC", "REFMAN.DOC", "LIBRARY.DOC", 
   "C.DOC", "BASIC.DOC", "RELNOTES.DOC", "INSTALL.DOC", "WEB.DOC", 
   "TROUBLE.DOC", "PLATFORM.DOC", "BIND.DOC", "PERFORM.DOC"}
}

-- Some imported routines, so we don't need any include files
-- to be available during the install

-- from file.e:

constant M_DIR   = 22,
	 M_CURRENT_DIR = 23

function dir(sequence name)
-- returns directory information
    return machine_func(M_DIR, name)
end function

function current_dir()
-- returns name of current working directory
    return machine_func(M_CURRENT_DIR, 0)
end function

-- from graphics.e:

constant M_SET_T_COLOR = 9,
	 M_VIDEO_CONFIG = 13,
	 M_GET_POSITION   = 25

constant VC_COLOR = 1

function video_config()
-- return sequence of information on video configuration
    return machine_func(M_VIDEO_CONFIG, 0)
end function

global procedure text_color(integer c)
-- set the foreground text color to c 
    machine_proc(M_SET_T_COLOR, c)
end procedure

function get_position()
-- return {line, column} of current cursor position
    return machine_func(M_GET_POSITION, 0)
end function

-- from wildcard.e:

constant TO_LOWER = 'a' - 'A' 

function upper(object x)
-- convert atom or sequence to upper case
    return x - (x >= 'a' and x <= 'z') * TO_LOWER
end function

function exist(sequence path)
-- check if file or directory exists
    return sequence(dir(path))
end function

object move_command
move_command = "C:\\DOS\\MOVE.EXE " -- DOS 6
if not exist(move_command) then
    move_command = "C:\\WINDOWS\\COMMAND\\MOVE.EXE " -- DOS 7
    if not exist(move_command) then
	move_command = -1 -- assume no move command
    end if
end if

sequence vc
vc = video_config()

integer color_monitor
color_monitor = vc[VC_COLOR]

procedure the_end()
-- exit install
    puts(SCREEN, "\nPress Enter...\n")
    if atom(gets(0)) then
    end if
    abort(0)
end procedure

procedure fore_color(integer c)
-- change foreground color
    if color_monitor then
	text_color(c)
    end if
end procedure

procedure move(sequence source, sequence dest)
-- move one file into a directory
    sequence p
    
    p = get_position()
    if p[2] > 65 then
	puts(SCREEN, "\n     ")
    end if
    puts(SCREEN, source & " ")
    -- MOVE (DOS 6,7)
    if sequence(move_command) then
	system(move_command & source & ' ' & dest & " > NUL", NO_CLEAR)
	if exist(dest & "\\" & source) then
	    return
	else
	    puts(SCREEN, "OK - no MOVE command - use COPY instead ...\n")
	    move_command = -1 -- doesn't work
	end if
    end if

    -- COPY (DOS 5 or earlier)
    system("copy " & source & ' ' & dest & " > NUL", NO_CLEAR)
    if exist(dest & "\\" & source) then
	system("del " & source, NO_CLEAR)
    else
	-- copy failed
	puts(SCREEN, "Unable to copy " & source & 
		     " to " & dest & " subdirectory\n")
	if exist(source) and exist("EUPHOR20.ZIP") then
	    puts(SCREEN, "Perhaps you can try again without the .zip file\n")
	end if
    end if
end procedure

procedure moveall()
-- move all files into the correct subdirectories
    sequence command

    puts(SCREEN, "Creating Euphoria Subdirectories ...")
    for i = 1 to length(file_list) do
	command = "mkdir " & file_list[i][1]
	fore_color(2)
	puts(SCREEN, "\n\n" & file_list[i][1] & ":\n     ")
	fore_color(7)
	system(command, NO_CLEAR) 
	for j = 2 to length(file_list[i]) do
	    move(file_list[i][j], file_list[i][1])
	end for
	-- Only Complete Edition has these files:
	if compare(file_list[i][1], "BIN") = 0 then
	    if exist("PDEX.EXE") then
		move("PDEX.EXE", "BIN")
	    end if
	    if exist("PDEXW.EXE") then
		move("PDEXW.EXE", "BIN")
	    end if
	end if
    end for
    puts(SCREEN, '\n')
end procedure

function unbundle()
-- unbundle files stored in bundle.dat
    integer bundle, newfile, size
    object line

    bundle = open("bundle.dat", "rb")
    if bundle = -1 then
	puts(SCREEN, "Couldn't find bundle.dat\n")
	return FAILURE
    end if

    puts(SCREEN, "Unbundling files...\n")

    -- skip first 3 lines
    line = gets(bundle)
    line = gets(bundle)
    line = gets(bundle)
    
    while TRUE do
	line = gets(bundle) -- file name
	if atom(line) then
	    exit -- EOF
	end if
	
	line = line[1..length(line)-1]
	
	if length(line) > 12 then
	    puts(SCREEN, "bundle.dat has been corrupted\n")
	    return FAILURE
	end if
	
	if compare(line, "EXW.EXE") = 0 then
	    if exist("EXW.EXE") then
		-- Complete EXW is there already
		-- Make this PDEXW
		line = "PDEXW.EXE"
	    end if
	end if
	
	newfile = open(line, "wb")
	if newfile = -1 then
	    puts(SCREEN, "Couldn't open " & line & " for write\n")
	    return FAILURE
	end if
	
	printf(SCREEN, "%s\t\t\t\r", {line})
	
	line = gets(bundle)  -- size of file
	if atom(line) then
	    puts(SCREEN, "bundle.dat has been corrupted\n")
	    return FAILURE
	end if
	
	-- compute size of file
	size = 0
	for i = 1 to length(line) do
	    if line[i] < '0' then
		exit
	    end if
	    size = size * 10 + line[i] - '0'
	end for
	
	if size < 20 or size > 200000 then
	    puts(SCREEN, "bundle.dat has been corrupted\n")
	    return FAILURE
	end if
	
	-- copy to file
	for i = 1 to size do
	    puts(newfile, getc(bundle))
	end for
	close(newfile)
    end while
    close(bundle)
    system("DEL BUNDLE.DAT", NO_CLEAR)
    return SUCCESS
end function

function setupdir()
-- set up subdirectories 

    if exist("BIN\\EX.EXE") then
	puts(SCREEN, "Subdirectory structure has already been set up\n")
	return SUCCESS
    end if
    if unbundle() = FAILURE then
	return FAILURE
    end if
    moveall()
    if not exist("BIN\\EX.EXE") then
	puts(SCREEN, "Subdirectory set up failed - see INSTALL.DOC\n")
	return FAILURE
    end if
    return SUCCESS
end function

procedure rename_it()
    puts(SCREEN, 
	 "Please remove it or rename it before installing a new version.\n")
end procedure

function copy_to_hard_disk(integer drive)
-- copy Euphoria files to EUPHORIA directory 
    sequence eu_dir, rename_dir
    integer rename_letter

    eu_dir = drive & ":\\EUPHORIA"

    if compare(upper(current_dir()), eu_dir) = 0 then
	-- we're in EUPHORIA directory already - just set up subdirectories
	return setupdir() 
    end if

    if exist(eu_dir) then
	puts(SCREEN,
	"An existing EUPHORIA directory was found on drive " & drive & ".\n")
	if sequence(move_command) then
	    rename_letter = 'F'
	    while rename_letter <= 'Z' do
		rename_dir = drive & ":\\" & rename_letter & "UPHORIA"
		if not exist(rename_dir) then
		    exit
		end if
		rename_letter = rename_letter + 1
	    end while
	    if rename_letter <= 'Z' then
		system(move_command & eu_dir & ' ' & rename_dir & "> NUL", NO_CLEAR)
		if exist(rename_dir) then
		    puts(SCREEN,"It has been renamed as " & rename_dir & "\n\n")
		else
		    rename_it()
		    return FAILURE
		end if
	    else
		rename_it()
		return FAILURE
	    end if
	else
	    rename_it()
	    return FAILURE
	end if
    end if

    puts(SCREEN, "The EUPHORIA files will now be copied to " & eu_dir & '\n')
    puts(SCREEN, "    * Press Enter to start copying. [recommended action]\n")
    puts(SCREEN, "    * or type ! to abort.\n")

    if find('!', gets(KEYBOARD)) then
	puts(SCREEN, "\ninstallation aborted - try again later\n")
	the_end()
    end if

    system("mkdir " & eu_dir, NO_CLEAR)
    if not exist(eu_dir) then
	puts(SCREEN, "\n\nCouldn't create " & eu_dir & ".\n")
	puts(SCREEN, "See install.doc\n")
	return FAILURE
    end if

    -- copy all files to EUPHORIA directory
    system("xcopy *.* " & eu_dir, CLEAR)
    if not exist(eu_dir & "\\EX.EXE") or 
       not exist(eu_dir & "\\INSTALL.EX") then 
	puts(SCREEN, "xcopy failed - trying copy\n")
	system("copy *.* " & eu_dir, CLEAR)
	if not exist(eu_dir & "\\EX.EXE") or 
	   not exist(eu_dir & "\\INSTALL.EX") then 
	    puts(SCREEN, "copy failed - see INSTALL.DOC\n")
	    return FAILURE
	end if
    end if

    -- copy worked, now cd to EUPHORIA
    system(drive & ':', NO_CLEAR)
    system("cd " & eu_dir, NO_CLEAR)
    if compare(upper(current_dir()), eu_dir) != 0 then
	puts(SCREEN, "cd failed - see install.doc\n")
	return FAILURE
    end if

    -- cd worked, now set up subdirectories
    return setupdir() 

end function

function Yes()
-- return TRUE if answer is "y"
    sequence answer
    
    while TRUE do
	answer = upper(gets(KEYBOARD))
	puts(SCREEN, '\n')
	if find('Y', answer) then
	    return TRUE
	elsif find('N', answer) then
	    return FALSE
	else
	    puts(SCREEN, "Please answer with y or n: ")
	end if
    end while
end function

constant MAX_PATH = 127 - length("C:\\EUPHORIA\\BIN; ")

function edit_auto_exec(integer drive)
-- edit the autoexec.bat file
-- add to the PATH, set EUDIR
    integer path_found, q, auto_exec_no, p, white, semi_pos
    sequence path, auto_exec, auto_name, base_name, answer, set_line
    object line

    path = getenv("PATH")
    if sequence(path) then
	path = upper(path)
	p = match("EUPHORIA\\BIN", path) 
	if p then
	    q = p + length("EUPHORIA\\BIN") - 1
	    while p > 1 do
		p = p - 1
		if path[p]=';' then
		    p = p + 1
		    exit
		end if
	    end while
	    puts(SCREEN, "\nYour current PATH already has " & path[p..q] & '\n')
	    return NO_EDIT
	end if
	if length(path) >= MAX_PATH then
	    puts(SCREEN, "\nYour current PATH is too long to add EUPHORIA\\BIN\n")
	    puts(SCREEN, "Perhaps you can remove a directory from it.\n")
	    return FAILURE
	end if
    end if
    
    puts(SCREEN, "\n\nEditing AUTOEXEC.BAT ...\n")
    set_line = "SET EUDIR=" & drive & ":\\EUPHORIA\n"
    base_name = ":\\AUTOEXEC.BAT"
    auto_name = "C" & base_name  -- try C first
    auto_exec = {}
    path_found = 0
    
    auto_exec_no = open(auto_name, "r")
    while auto_exec_no = -1 do
	puts(SCREEN, "Couldn't open " & auto_name & '\n')
	puts(SCREEN, "On what drive is your AUTOEXEC.BAT file?\n")
	puts(SCREEN, "Type a letter: (! to abort)\n")
	answer = gets(KEYBOARD)
	if find('!', answer) then
	    puts(SCREEN, "creating C:\\AUTOEXEC.BAT\n")
	    exit
	end if
	auto_name = answer[1] & base_name
	auto_exec_no = open(auto_name, "r")
    end while
    
    while auto_exec_no != -1 do
	-- read next line from autoexec.bat
	line = gets(auto_exec_no)
	if atom(line) then
	    exit
	end if
	p = match("PATH", upper(line))
	if p then
	    -- line contains the word "PATH" in upper or lower case
	    -- at position p
	    white = TRUE
	    q = p - 1
	    while q >= 1 do
		if not find(line[q], " \t") then
		    -- non whitespace - only "SET" is allowed
		    if q >= 3 then
			if compare("SET", upper(line[q-2..q])) = 0 then
			    q = q - 2
			else
			    white = FALSE
			    exit
			end if
		    else
			white = FALSE
			exit
		    end if
		end if
		q = q - 1
	    end while

	    if white and find(line[p+4], " \t=") then
		-- this is a PATH line
		path_found = path_found + 1
		if path_found = 1 then
		    -- only change the first one encountered
		    auto_exec = append(auto_exec, set_line)
		    if match(drive & ":\\EUPHORIA\\BIN", upper(line)) then
			-- its already there
			puts(SCREEN, "PATH already has " & drive & 
				     ":\\EUPHORIA\\BIN\n")
			close(auto_exec_no)
			return NO_EDIT
		    end if
		    if length(line) > MAX_PATH then
			-- line is too long (MS-DOS restriction)
			puts(SCREEN, 
			"Your PATH line is too long to add EUPHORIA\\BIN\n")
			puts(SCREEN, 
			"Perhaps you can delete a directory from it.\n")
			puts(SCREEN, 
			"No changes were made to your AUTOEXEC.BAT file.\n")
			close(auto_exec_no)
			return FAILURE
		    end if
		    semi_pos = find(';', line)
		    if semi_pos = 0 then
			semi_pos = length(line)
			line = line[1..length(line)-1] & ";\n"
		    end if
		    -- add EUPHORIA\BIN to path
		    puts(SCREEN, "Changing this line:\n")
		    fore_color(2)
		    puts(SCREEN, line)
		    fore_color(7)
		    puts(SCREEN, "to:\n")
		    fore_color(2)
		    puts(SCREEN, line[1..semi_pos])
		    fore_color(4)
		    puts(SCREEN, drive & ":\\EUPHORIA\\BIN;")
		    fore_color(2)
		    puts(SCREEN, line[semi_pos+1..length(line)])
		    line = line[1..semi_pos] &
			   drive & ":\\EUPHORIA\\BIN;" &
			   line[semi_pos+1..length(line)]
		    fore_color(7)
		    puts(SCREEN, "and inserting the following line:\n")
		    fore_color(4)
		    puts(SCREEN, set_line)
		    fore_color(7)
		end if
	    end if
	end if
	auto_exec = append(auto_exec, line)
    end while

    if auto_exec_no = -1 or not path_found then
	-- no autoexec.bat file, or no PATH command was found - make one:
	line = "SET PATH=%PATH%;" & drive & ":\\EUPHORIA\\BIN\n"
	puts(SCREEN, "adding the following lines:\n")
	fore_color(4)
	puts(SCREEN, set_line)
	puts(SCREEN, line)
	fore_color(7)
	auto_exec = append(auto_exec, set_line)
	auto_exec = append(auto_exec, line)
	path_found = 1
    end if
    
    -- write out the new autoexec.bat
    puts(SCREEN, 
    "Is it OK to make these changes to your AUTOEXEC.BAT file? (y or n) \n")
    puts(SCREEN, "-----> ") 
    if not Yes() then
	return FAILURE
    end if
    if path_found = 2 then
	puts(SCREEN, "One other \"PATH\" line was found but not changed.\n") 
	puts(SCREEN, "Please take a look at it.\n")
    elsif path_found > 2 then
	printf(SCREEN, "%d other \"PATH\" lines were found but not changed.\n",
	path_found - 1)
	puts(SCREEN, "Please take a look at them.\n")
    end if
    if auto_exec_no != -1 then
	close(auto_exec_no)
    end if
    auto_exec_no = open(auto_name, "w")
    if auto_exec_no = -1 then
	puts(SCREEN, "Couldn't write out the new AUTOEXEC.BAT!\n")
	puts(SCREEN, "Your AUTOEXEC.BAT file is read-only.\n")
	return FAILURE
    end if
    for i = 1 to length(auto_exec) do
	puts(auto_exec_no, auto_exec[i])
    end for
    close(auto_exec_no)
    return SUCCESS
end function

procedure install()
-- main routine for Euphoria installation
    integer drive
    integer edit_status
    sequence answer

    clear_screen()
    fore_color(5)
    puts(SCREEN, "\nEuphoria")
    fore_color(7)
    puts(SCREEN, " Installation Program\n\n")

    if not exist("EX.EXE") then
	if exist("BIN\\EX.EXE") 
	   and exist("DEMO\\SANITY.EX") then
	    puts(SCREEN, "You have already installed Euphoria.\n")
	    puts(SCREEN, "If you need to set up AUTOEXEC.BAT see INSTALL.DOC.\n")
	else
	    puts(SCREEN, 
		"All files must be together in one directory to run install.\n")
	end if
	return
    end if

    puts(SCREEN, "On which drive do you want to put the EUPHORIA directory?\n")
    puts(SCREEN, "Type the drive letter, or just hit Enter for drive C\n")
    puts(SCREEN, "-----> ")

    answer = upper(gets(KEYBOARD))

    while answer[1] = ' ' or answer[1] = '\t' do
	answer = answer[2..length(answer)]
    end while

    drive = answer[1]
    if drive < 'A' or drive > 'Z' then
	drive = 'C'
    end if

    puts(SCREEN, '\n')

    if copy_to_hard_disk(drive) = FAILURE then
	return
    end if

    edit_status = edit_auto_exec(drive)

    if edit_status = FAILURE then
	puts(SCREEN, 
	  "To complete the install you should edit AUTOEXEC.BAT manually.\n") 
	puts(SCREEN, 
	  "See DOC\\INSTALL.DOC - How To Manually Edit AUTOEXEC.BAT\n")
	return
    end if

    puts(SCREEN, "\nInstall Completed.\n")
    if edit_status = NO_EDIT then
	puts(SCREEN, 
	"You might start by looking at README.DOC or DOC\\OVERVIEW.DOC\n")
    else
	puts(SCREEN, "After pressing Enter, you should remove any floppy disks,\n")
	puts(SCREEN, "and then ")
	fore_color(2)
	puts(SCREEN, "reboot (restart) your computer")
	fore_color(7)
	puts(SCREEN, ".\nThis will set your PATH and EUDIR variables.\n\n")
	puts(SCREEN, "When the system is back up you might start\n")  
	puts(SCREEN, "by looking at README.DOC or DOC\\OVERVIEW.DOC.\n")
	puts(SCREEN, 
	"The Euphoria editor, ed, will be available - see DOC\\ED.DOC.\n")
    end if
    puts(SCREEN, "\n\t\tEnjoy!\n")
end procedure

install()
the_end()

